% 7 point registration, leave 1 test point

clc
tic;
close all;
clear all;

% load 'SC Coordinates';
load 'SC Coordinates in mm';
load 'US Coordinates and Bpost Images';

dataSC = [SC1 SC2 SC3 SC4 SC5 SC6 SC7 SC8];
dataUS = [UScoor1 UScoor2 UScoor3 UScoor4 UScoor5 UScoor6 UScoor7 UScoor8];
dataIndex = [1 2 3 4 5 6 7 8];
chooseN = 8;
chooseK = 7;

SC_Combinations = combomatrix_AC(dataSC, chooseN, chooseK);
US_Combinations = combomatrix_AC(dataUS, chooseN, chooseK);
index_of_vectors = combomatrix_AC(dataIndex, chooseN, chooseK);

RegPointsSC_All=SC_Combinations(:,1:chooseK);
TestPointsSC_All=SC_Combinations(:,chooseK+1);

RegPointsUS_All=US_Combinations(:,1:chooseK);
TestPointsUS_All=US_Combinations(:,chooseK+1);

Error_Matrix_Full=[];
Dimensional_Error=[];
Avg_Dist_Full=[];
Error_Using_Corr=[];
CorrCoeff_Full=[];
Theoretical_Coordinates_Full=[];
Actual_Coordinates_Full=[];
linear_coeff = 0.7;

figure(1)
title('Beamformed Image Minimum Error Using Correlation Coefficient');
axis square;
xlabel('mm');
ylabel('mm');
hold on;
        
for k=1:3:length(RegPointsSC_All(:,1))
    
    RegPointsSC_temp=RegPointsSC_All(k:k+2,:);
    TestPointsSC_temp=TestPointsSC_All(k:k+2,:);
    
    RegPointsUS_temp=RegPointsUS_All(k:k+2,:);
    TestPointsUS_temp=TestPointsUS_All(k:k+2,:);
    
    [R_temp p_temp] = PointCloudTransform(RegPointsSC_temp,RegPointsUS_temp);
    
    theoretical_us_point = R_temp*TestPointsSC_temp + p_temp;
%     theoretical_us_point(1,1) = theoretical_us_point(1,:);
%     theoretical_us_point(2,1) = theoretical_us_point(2,:);
    Theoretical_Coordinates_Full=[Theoretical_Coordinates_Full; theoretical_us_point'];
    
    actual_us_point = [TestPointsUS_temp(1,1) TestPointsUS_temp(2) 0]';
    Actual_Coordinates_Full=[Actual_Coordinates_Full; actual_us_point(1:2,:)'];
    
%     figure
%     title('Beamformed Image Minimum Error Using Correlation Coefficient');
%     axis square;
%     xlabel('mm');
%     ylabel('mm');
%     hold on;
    plot(theoretical_us_point(1,1),theoretical_us_point(2,1),'gh','MarkerFaceColor','g');
    plot(actual_us_point(1,1),actual_us_point(2,1),'rh','MarkerFaceColor','r');
    x = [actual_us_point(1,1);theoretical_us_point(1,1)];
    y = [actual_us_point(2,1);theoretical_us_point(2,1)];
    plot(x,y,'b');
    text(x(1)+0.5,y(1),num2str((k-1)/3 +1));
    legend('Computed','Actual');
    
    temp_error=norm(theoretical_us_point-actual_us_point);
    Error_Matrix_Full=[Error_Matrix_Full; temp_error]
    
    conv_pt1=[RegPointsUS_temp(1,1) RegPointsUS_temp(2,1) 0]';
    conv_pt2=[RegPointsUS_temp(1,2) RegPointsUS_temp(2,2) 0]';
    conv_pt3=[RegPointsUS_temp(1,3) RegPointsUS_temp(2,3) 0]';
    
    dist1=norm(conv_pt1-conv_pt2);
    dist2=norm(conv_pt2-conv_pt3);
    dist3=norm(conv_pt3-conv_pt1);
    
    avg_dist_temp=(dist1+dist2+dist3)/3;
    Avg_Dist_Full=[Avg_Dist_Full; avg_dist_temp];
    
    x_fit=[conv_pt1(1,1) conv_pt2(1,1) conv_pt3(1,1)]';
    y_fit=[conv_pt1(2,1) conv_pt2(2,1) conv_pt3(2,1)]';
    
    p=polyfit(x_fit,y_fit,1);
    output=polyval(p',x_fit);
    CorrCoeff_temp=corrcoef(y_fit, output);
    
    CorrCoeff_Full=[CorrCoeff_Full; CorrCoeff_temp(1,2)];
    
%     if CorrCoeff_temp(1,2)<linear_coeff
        Error_Using_Corr=[Error_Using_Corr; temp_error (k+2)/3];
        Dimensional_Error=[Dimensional_Error; norm(theoretical_us_point(1,1)-actual_us_point(1,1)) norm(theoretical_us_point(2,1)-actual_us_point(2,1)) norm(theoretical_us_point(3,1)-actual_us_point(3,1))];
%     end
    
end

%%%% Calculates Error Using Correlation Coefficient Method %%%%%%%%%%%

Average_Errorcorr=mean(Error_Using_Corr(:,1));
Stddev_Errorcorr=std(Error_Using_Corr(:,1));
Average_DimError_CoorX=mean(Dimensional_Error(:,1));
Average_DimError_CoorY=mean(Dimensional_Error(:,2));
Average_DimError_CoorZ=mean(Dimensional_Error(:,3));
Std_Dev_CoorX=std(Dimensional_Error(:,1));
Std_Dev_CoorY=std(Dimensional_Error(:,2));
Std_Dev_CoorZ=std(Dimensional_Error(:,3));
Min_Err_CoorX=min(Dimensional_Error(:,1));
Min_Err_CoorY=min(Dimensional_Error(:,2));
Min_Err_CoorZ=min(Dimensional_Error(:,3));
Max_Err_CoorX=max(Dimensional_Error(:,1));
Max_Err_CoorY=max(Dimensional_Error(:,2));
Max_Err_CoorZ=max(Dimensional_Error(:,3));

%%%% Plots All Error Plots Using Corr. Coeff Method %%%%%%%%%
% const = 80;
% for i=1:size(Error_Using_Corr,1)/const
%     figure(i)
%     for j=1:const
%         title('Beamformed Image Minimum Error Using Correlation Coefficient');
%         axis square;
%         xlabel('mm');
%         ylabel('mm');
%         hold on;
%         actual_us_point_min = Actual_Coordinates_Full(const*i+j,1:2);
%         theoretical_us_point_min =  Theoretical_Coordinates_Full(const*i+j,1:2);
%         plot(actual_us_point_min(1,1),actual_us_point_min(1,2),'gh','MarkerFaceColor','g');
%         plot(theoretical_us_point_min(1,1),theoretical_us_point_min(1,2),'rh','MarkerFaceColor','r');
%         x = [actual_us_point_min(1,1);theoretical_us_point_min(1,1)];
%         y = [actual_us_point_min(1,2);theoretical_us_point_min(1,2)];
%         plot(x,y,'b');
%     end
% end



toc