% N-1 point registration, leave 1 test point

clc
tic;
% close all;
% clear all;

% load 'SC Coordinates';
% load 'SCCoord2162012';
% load 'USCoord2162012New2';

% 2292012 Data
% load 'SCCoord2292012';
% load 'USCoord2292012Centroid';
% load 'USCoord2292012WtCentroid';
% load 'USCoord2292012Ellipse';
% load 'USCoord2292012Max';
% load 'USCoord2292012Rect';
% load 'USCoord2292012EllipseAll';

% 3092012 Data
% load 'SCCoord3092012';
% load 'USCoord3092012Centroid';
% load 'USCoord3092012WtCentroid';
% load 'USCoord3092012Ellipse';
% load 'USCoord3092012Max';
% load 'USCoord3092012Rect';
% load 'USCoord3092012EllipseAll';

% 3202012 Data
% load 'SCCoord3202012';
% load 'USCoord3202012Centroid';
% load 'USCoord3202012WtCentroid';
% load 'USCoord3202012Ellipse';
% load 'USCoord3202012Max';
% load 'USCoord3202012Rect';
% load 'USCoord3202012EllipseAll';

% 3202012 Data DelaySum
% load 'testSCData.mat';
% load 'testUSData.mat';

% 4132012 Data
% load 'SCCoordL4132012';
% load 'SCCoordR4132012';
% load 'USCoord4132012EllipseAll';

% 4132012 Data New Scan Conversion
% load 'SCCoord2L4132012';
% load 'SCCoord2R4132012';
% load 'SCCoord2L41320122';
% load 'SCCoord2R41320122';
% load 'USCoord4132012EllipseAll2';
% load 'USCoord4132012EllipseAll3';
% load 'USCoord4132012EllipseAll4';
% load 'USCoord4132012EllipseAll5';

% 4202012 Data New Scan Conversion
% load 'SCCoordL4202012';
% load 'SCCoordR4202012';
% load 'SCCoordL42020122';
% load 'SCCoordR42020122';
% load 'SCCoordL42020123';
load 'SCCoordR42020123';
% load 'USCoord4202012EllipseAll';
% load 'USCoord4202012EllipseAll2';
load 'USCoord4202012EllipseAll3';


% load 'testSCData2.mat';
% load 'testUSData2.mat';

[~, chooseN] = size(dataSC);
chooseK = chooseN - 1;

SC_Combinations = combomatrix_AC(dataSC, chooseN, chooseK);
US_Combinations = combomatrix_AC(dataUS, chooseN, chooseK);

RegPointsSC_All=SC_Combinations(:,1:chooseK);
TestPointsSC_All=SC_Combinations(:,chooseK+1);

RegPointsUS_All=US_Combinations(:,1:chooseK);
TestPointsUS_All=US_Combinations(:,chooseK+1);

Error_Matrix_Full=[];
Dimensional_Error=[];
Theoretical_Coordinates_Full=[];
Actual_Coordinates_Full=[];

figure
title('US and SC Test Points in US Frame');
axis equal;
xlabel('X mm');
ylabel('Y mm');
zlabel('Z mm');
hold on;

e_Full = [];

for k=1:3:length(RegPointsSC_All(:,1))
    
    RegPointsSC_temp=RegPointsSC_All(k:k+2,:);
    TestPointsSC_temp=TestPointsSC_All(k:k+2,:);
    
    RegPointsUS_temp=RegPointsUS_All(k:k+2,:);
    TestPointsUS_temp=TestPointsUS_All(k:k+2,:);
    
    [R_temp p_temp] = PointCloudTransform(RegPointsSC_temp,RegPointsUS_temp);
    % [R_temp p_temp] = PointCloudAffineTransform(RegPointsSC_temp,RegPointsUS_temp);
    % [R_temp p_temp] = icp(dataUS,dataSC);
    
    theoretical_us_point = R_temp*TestPointsSC_temp + p_temp;
    Theoretical_Coordinates_Full=[Theoretical_Coordinates_Full; theoretical_us_point'];
    
    actual_us_point = TestPointsUS_temp;
    Actual_Coordinates_Full=[Actual_Coordinates_Full; actual_us_point'];
    
    for i = 1:1:chooseN
        eDim(:,i) = dataUS(:,i) - (R_temp*dataSC(:,i) + p_temp);
        e(i) = norm(eDim(:,i));
    end
    
    e_Full = [e_Full; e];
    
    plot3(theoretical_us_point(1,1),theoretical_us_point(2,1),theoretical_us_point(3,1),'gh','MarkerFaceColor','g');
    plot3(actual_us_point(1,1),actual_us_point(2,1),actual_us_point(3,1),'rh','MarkerFaceColor','r');
    x = [actual_us_point(1,1);theoretical_us_point(1,1)];
    y = [actual_us_point(2,1);theoretical_us_point(2,1)];
    z = [actual_us_point(3,1);theoretical_us_point(3,1)];
    plot3(x,y,z,'b');
    text(x(1)+0.5,y(1),z(1),num2str(chooseN - (k-1)/3));
    legend('Transformed SC','Segmented US');
    
    temp_error=norm(theoretical_us_point-actual_us_point);
    Error_Matrix_Full=[Error_Matrix_Full; temp_error];
    
    Dimensional_Error=[Dimensional_Error; norm(theoretical_us_point(1,1)-actual_us_point(1,1)) norm(theoretical_us_point(2,1)-actual_us_point(2,1)) norm(theoretical_us_point(3,1)-actual_us_point(3,1))];
    
end

[R p] = PointCloudAffineTransform(Theoretical_Coordinates_Full,Actual_Coordinates_Full);
[U,S,V] = svd(R);

% [R p] = PointCloudAffineTransform(dataSC,dataUS)
% [U,S,V] = svd(R)

for i = 1:1:size(e_Full,1)
    [errorMeans(i) newE_Full(i,:)] = meanError(e_Full(i,:));
end

%%%% Calculates Error Using Correlation Coefficient Method %%%%%%%%%%%

Average_DimError_CoorX=mean(Dimensional_Error(:,1));
Average_DimError_CoorY=mean(Dimensional_Error(:,2));
Average_DimError_CoorZ=mean(Dimensional_Error(:,3));
Average_Error_Full = mean(Error_Matrix_Full);
Std_Dev_CoorX=std(Dimensional_Error(:,1));
Std_Dev_CoorY=std(Dimensional_Error(:,2));
Std_Dev_CoorZ=std(Dimensional_Error(:,3));
Std_Dev_Full = std(Error_Matrix_Full);
Min_Err_CoorX=min(Dimensional_Error(:,1));
Min_Err_CoorY=min(Dimensional_Error(:,2));
Min_Err_CoorZ=min(Dimensional_Error(:,3));
Min_Err_Full = min(Error_Matrix_Full);
Max_Err_CoorX=max(Dimensional_Error(:,1));
Max_Err_CoorY=max(Dimensional_Error(:,2));
Max_Err_CoorZ=max(Dimensional_Error(:,3));
Max_Err_Full = max(Error_Matrix_Full);

Full = [Dimensional_Error Error_Matrix_Full];

toc