% Calculating the FRE

clc
tic;
close all;
% clear all;

% load 'SC Coordinates';
% load USCoord2242012New;
% load SCCoord2242012;
% 
% load USCoord2162012New2;
% load SCCoord2162012;

% load 'SCCoord2292012Rot';
% load 'USCoord2292012Rot';

% 3092012 Data
load 'SCCoord3092012';
% load 'USCoord3092012Centroid';
% load 'USCoord3092012WtCentroid';
% load 'USCoord3092012Ellipse';
% load 'USCoord3092012Max';
load 'USCoord3092012Rect';

% OrigDataSC = [SC1 SC2 SC3 SC4 SC5 SC6 SC7];
% OrigDataUS = [US1 US2 US3 US4 US5 US6 US7];
% OrigDataIndex = [1 2 3 4 5 6 7];

% OrigDataSC = [SC1 SC3 SC4 SC6 SC7 SC8 SC9];
% OrigDataUS = [US1 US3 US4 US6 US7 US8 US9];
OrigDataSC = dataSC;
OrigDataUS = dataUS;
OrigDataIndex = [1 3 4 6 7 8 9];

test = 1;
n = 7;

Error_Matrix_X = zeros(1,n);
Error_Matrix_Y = zeros(1,n);
Error_Matrix_Z = zeros(1,n);
Error_Matrix_Full=zeros(1,n);
d_X = zeros(1,n);
d_Y = zeros(1,n);
d_Z = zeros(1,n);
d_Full = zeros(1,n);
M = [];
Singular = [];

dataSC = OrigDataSC;
dataUS = OrigDataUS;
dataIndex = OrigDataIndex;

[R_temp p_temp] = PointCloudTransform(dataSC,dataUS);

figure(1)
title('US Space, Computed vs Actual');
axis equal;
xlabel('Lateral mm');
ylabel('Axial mm');
zlabel('Elevational mm');
hold on;

figure(2)
title('SC Points');
axis equal;
xlabel('X mm');
ylabel('Y mm');
zlabel('Z mm');
hold on;

for k = 1:1:n
    
    calcUS = R_temp*dataSC(:,k) + p_temp;
    temp_error = calcUS - dataUS(:,k);
    
    figure(1)
    plot3(calcUS(1,1),calcUS(2,1),calcUS(3,1),'gh','MarkerFaceColor','g');
    plot3(dataUS(1,k),dataUS(2,k),dataUS(3,k),'rh','MarkerFaceColor','r');
    x = [dataUS(1,k);calcUS(1,1)];
    y = [dataUS(2,k);calcUS(2,1)];
    z = [dataUS(3,k);calcUS(3,1)];
    plot3(x,y,z,'b');
    text(x(1)+0.5,y(1),z(1),num2str(k));
    legend('Computed','Actual');
    
    figure(2)
    plot3(dataSC(1,k),dataSC(2,k),dataSC(3,k),'rh','MarkerFaceColor','r');
    text(dataSC(1,k)+0.5,dataSC(2,k),dataSC(3,k),num2str(k));
    
    Error_Matrix_X(k) = abs(temp_error(1));
    Error_Matrix_Y(k) = abs(temp_error(2));
    Error_Matrix_Z(k) = abs(temp_error(3));
    Error_Matrix_Full(k) = norm(temp_error);
    
    tempM = [-skew(dataSC(:,k)) eye(3)];
    M = [M;tempM];
    
end

[U,S,V] = svd(M);
Singular = [Singular; S(1,1) S(2,2) S(3,3) S(4,4) S(5,5) S(6,6)];

Mean_Error_X = mean(Error_Matrix_X(test,:));
Mean_Error_Y = mean(Error_Matrix_Y(test,:));
Mean_Error_Z = mean(Error_Matrix_Z(test,:));
Mean_Full = mean(Error_Matrix_Full(test,:));


for i = 1:1:n
    
    d_X(i) = Error_Matrix_X(i) - Mean_Error_X;
    d_Y(i) = Error_Matrix_Y(i) - Mean_Error_Y;
    d_Z(i) = Error_Matrix_Z(i) - Mean_Error_Z;
    d_Full(i) = Error_Matrix_Full(i) - Mean_Full;
    
end

meanDX = mean(abs(d_X));
meanDY = mean(abs(d_Y));
meanDZ = mean(abs(d_Z));
meanDFull = mean(abs(d_Full));

varDX = var(abs(d_X));
varDY = var(abs(d_Y));
varDZ = var(abs(d_Z));
varDFull = var(abs(d_Full));

stdDX = std(abs(d_X));
stdDY = std(abs(d_Y));
stdDZ = std(abs(d_Z));
stdDFull = std(abs(d_Full));

STD_X = std(Error_Matrix_X(test,:));
STD_Y = std(Error_Matrix_Y(test,:));
STD_Z = std(Error_Matrix_Z(test,:));
STD_Full = std(Error_Matrix_Full(test,:));

test = test + 1;

X = [Error_Matrix_X Mean_Error_X STD_X];
Y = [Error_Matrix_Y Mean_Error_Y STD_Y];
Z = [Error_Matrix_Z Mean_Error_Z STD_Z];
Full = [Error_Matrix_X' Error_Matrix_Y' Error_Matrix_Z' Error_Matrix_Full'];

DX = [d_X meanDX varDX stdDX];
DY = [d_Y meanDY varDY stdDY];
DZ = [d_Z meanDZ varDZ stdDZ];
DFull = [d_Full meanDFull varDFull stdDFull];

toc