% 6 point registration, leave 1 test point

clc
tic;
close all;
clear all;

load 'SCCoord2292012';
load 'USCoord2292012';

dataSC = [SC1 SC2 SC5 SC6 SC7 SC9 SC10];
dataUS = [US1 US2 US5 US6 US7 US9 US10];
SCFid = [SCFid1 SCFid3];
USFid = [USFid1 USFid3];
dataIndex = [1 2 3 4 5 6 7];

Error_Matrix_Full=[];
Dimensional_Error=[];
Theoretical_Coordinates_Full=[];
Actual_Coordinates_Full=[];

n = 7;
test = 2;

[R_temp p_temp] = PointCloudTransform(dataSC,dataUS);

figure(1)
title('Beamformed Image Minimum Error Using Correlation Coefficient');
axis equal;
xlabel('X mm');
ylabel('Y mm');
zlabel('Z mm');
hold on;

for k=1:1:test
    
    theoretical_us_point = R_temp*SCFid(:,k) + p_temp;

    Theoretical_Coordinates_Full=[Theoretical_Coordinates_Full; theoretical_us_point'];
    
    actual_us_point = USFid(:,k);
    Actual_Coordinates_Full=[Actual_Coordinates_Full; actual_us_point'];
    
    plot3(theoretical_us_point(1,1),theoretical_us_point(2,1),theoretical_us_point(3,1),'gh','MarkerFaceColor','g');
    plot3(actual_us_point(1,1),actual_us_point(2,1),actual_us_point(3,1),'rh','MarkerFaceColor','r');
    x = [actual_us_point(1,1);theoretical_us_point(1,1)];
    y = [actual_us_point(2,1);theoretical_us_point(2,1)];
    z = [actual_us_point(3,1);theoretical_us_point(3,1)];
    plot3(x,y,z,'b');
    text(x(1)+0.5,y(1)+0.5,z(1)+0.5,num2str(k));
    legend('Computed','Actual');
    
    temp_error=norm(theoretical_us_point-actual_us_point);
    Error_Matrix_Full=[Error_Matrix_Full; temp_error];
    
    Dimensional_Error=[Dimensional_Error; norm(theoretical_us_point(1,1)-actual_us_point(1,1)) norm(theoretical_us_point(2,1)-actual_us_point(2,1)) norm(theoretical_us_point(3,1)-actual_us_point(3,1))];
    
end

Average_DimError_CoorX=mean(Dimensional_Error(:,1));
Average_DimError_CoorY=mean(Dimensional_Error(:,2));
Average_DimError_CoorZ=mean(Dimensional_Error(:,3));
Std_Dev_CoorX=std(Dimensional_Error(:,1));
Std_Dev_CoorY=std(Dimensional_Error(:,2));
Std_Dev_CoorZ=std(Dimensional_Error(:,3));

Full = [Dimensional_Error Error_Matrix_Full];

toc