% Using another estimator for fiducial error

clc
tic;
close all;
clear all;

% load 'SC Coordinates';
load 'SC Coordinates in mm';
load 'US Coordinates and Bpost Images';

OrigDataSC = [SC1 SC2 SC3 SC4 SC5 SC6 SC7 SC8];
OrigDataUS = [UScoor1 UScoor2 UScoor3 UScoor4 UScoor5 UScoor6 UScoor7 UScoor8];
OrigDataIndex = [1 2 3 4 5 6 7 8];

test = 1;
n = 8;

Error_Matrix_X = zeros(1,n);
Error_Matrix_Y = zeros(1,n);
Error_Matrix_Z = zeros(1,n);
Error_Matrix_Full=zeros(1,n);
d_X = zeros(1,n);
d_Y = zeros(1,n);
d_Z = zeros(1,n);
d_Full = zeros(1,n);
M = [];
Singular = [];

dataSC = OrigDataSC;
dataUS = OrigDataUS;
dataIndex = OrigDataIndex;

[R_temp p_temp] = PointCloudTransform(dataSC,dataUS);

% figure
% title('Beamformed Image Minimum Error Using Correlation Coefficient');
% axis equal;
% xlabel('mm');
% ylabel('mm');
% hold on;

for k = 1:1:n
    
    calcUS = R_temp*dataSC(:,k) + p_temp;
    temp_error = calcUS - dataUS(:,k);
    
    %         plot(calcUS(1,1),calcUS(2,1),'gh','MarkerFaceColor','g');
    %         plot(dataUS(1,k),dataUS(2,k),'rh','MarkerFaceColor','r');
    %         x = [dataUS(1,k);calcUS(1,1)];
    %         y = [dataUS(2,k);calcUS(2,1)];
    %         plot(x,y,'b');
    %         text(x(1)+0.5,y(1),num2str(k));
    %         legend('Computed','Actual');
    
    Error_Matrix_X(k) = abs(temp_error(1));
    Error_Matrix_Y(k) = abs(temp_error(2));
    Error_Matrix_Z(k) = abs(temp_error(3));
    Error_Matrix_Full(k) = norm(temp_error);
    
    tempM = [-skew(dataSC(:,k)) eye(3)];
    M = [M;tempM];
    
end

[U,S,V] = svd(M);
Singular = [Singular; S(1,1) S(2,2) S(3,3) S(4,4) S(5,5) S(6,6)];

Mean_Error_X = mean(Error_Matrix_X(test,:));
Mean_Error_Y = mean(Error_Matrix_Y(test,:));
Mean_Error_Z = mean(Error_Matrix_Z(test,:));
Mean_Full = mean(Error_Matrix_Full(test,:));


for i = 1:1:n
    
    d_X(i) = Error_Matrix_X(i) - Mean_Error_X;
    d_Y(i) = Error_Matrix_Y(i) - Mean_Error_Y;
    d_Z(i) = Error_Matrix_Z(i) - Mean_Error_Z;
    d_Full(i) = Error_Matrix_Full(i) - Mean_Full;
    
end

meanDX = mean(abs(d_X));
meanDY = mean(abs(d_Y));
meanDZ = mean(abs(d_Z));
meanDFull = mean(abs(d_Full));

varDX = var(abs(d_X));
varDY = var(abs(d_Y));
varDZ = var(abs(d_Z));
varDFull = var(abs(d_Full));

stdDX = std(abs(d_X));
stdDY = std(abs(d_Y));
stdDZ = std(abs(d_Z));
stdDFull = std(abs(d_Full));

STD_X = std(Error_Matrix_X(test,:));
STD_Y = std(Error_Matrix_Y(test,:));
STD_Z = std(Error_Matrix_Z(test,:));
STD_Full = std(Error_Matrix_Full(test,:));

test = test + 1;


X = [Error_Matrix_X Mean_Error_X STD_X];
Y = [Error_Matrix_Y Mean_Error_Y STD_Y];
Z = [Error_Matrix_Z Mean_Error_Z STD_Z];
Full = [Error_Matrix_Full Mean_Full STD_Full];

DX = [d_X meanDX varDX stdDX];
DY = [d_Y meanDY varDY stdDY];
DZ = [d_Z meanDZ varDZ stdDZ];
DFull = [d_Full meanDFull varDFull stdDFull];

toc