function [ R, p ] = PointCloudAffineTransform( pointSet1, pointSet2 )
%POINTCLOUDAFFINETRANSFORM Summary of this function goes here
%   Detailed explanation goes here

[nd1, ns1] = size(pointSet1);
[nd2, ns2] = size(pointSet2);

if (nd1 ~= nd2) || (ns1 ~= ns2)
    R = [];
    p = [];
    return;
end

if (nd1 > ns1)
    temp = ns1;
    nd1 = ns1;
    ns1 = temp;
    pointSet1 = pointSet1';
end

if (nd2 > ns2)
    temp = ns2;
    nd2 = ns2;
    ns2 = temp;
    pointSet2 = pointSet2';
end

tempA = zeros(nd1,(nd1+1)*nd1);
A = zeros(nd1*ns1,(nd1+1)*nd1);
B = zeros(nd2*ns2,1);

for i = 1:1:ns1
    for j = 1:1:nd1
        tempA(j,((nd1+1)*(j-1)+1):((nd1+1)*j)) = [pointSet1(:,i)' 1];
    end
    A((nd1*(i-1)+1):(nd1*i),:) = tempA;
    B((nd2*(i-1)+1):(nd2*i)) = pointSet2(:,i);
end

x = lsqlin(A,B);

R = [x(1:3)';x(5:7)';x(9:11)'];
p = [x(4);x(8);x(12)];

end

