function [ RFslice, p_zx, Bpre, Bpost, x, y, z ] = beamformImage( filePath, frame )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

%Initialization for AMS probe
nCh = 128;              % number of channels
reRoute = true;         % true: transducer element (correct image), false: DAQ element
channels = ones(1,nCh);   % what channels to read (DAQ element), for each channel set to 1
dx = (38.4e-3)/128;
dz = 0.1;
dt = 1/(40e6);
speedSound = 1540;
aperture = 4;
probeL = 38.4;

[~, RFslice] = readDAQ(filePath, channels, frame, reRoute); % reads DAQ data

y = [1 size(RFslice,1)] * dt * speedSound * 1e3;
x = [1 size(RFslice,2)] * dx * 1e-3;
z = [1 size(RFslice,3)] * dz;

Bpre = abs(hilbert(RFslice));  % Computes prebeamform image

p_zx = kspaceLineRecon(RFslice,dx,dt,speedSound);
Bpost = abs(hilbert(p_zx));

% p_zx = beamformDAQ(RFslice, aperture, probeL); % Computes beamformed image
% Bpost = abs(hilbert(p_zx)); % Processes beamformed image

Bpost(1:50,:) = 0;
Bpost(1950:2000,:) = 0;

end

