function [ R, p ] = coherencePointDrift( dataTo, dataFrom )
%COHERENCEPOINTDRIFT Summary of this function goes here
%   Detailed explanation goes here

[D, N] = size(dataTo);
[~, M] = size(dataFrom);

R = eye(3);
p = zeros(3,1);
s = 1;
w = 0.5;
var = 0;
err = 1;

P = zeros(N,M);

for i = 1:1:N
    for j = 1:1:M
        var = var + norm(dataTo(:,i) - dataFrom(:,j));
    end
end

var = (1/D*N*M)*var;

% while (var > err)
for times = 1:1:10
    for i = 1:1:M
        for j = 1:1:N
            denominator = (2 * pi * var)^(D/2) * (2 / (1 - w)) * M/N;
            numerator = exp( (- 1 / (2 * var)) * norm( dataTo(:,i) - (s*R*dataFrom(:,j) + p) ) );
            for k = 1:1:M
                denominator = denominator + exp( (- 1 / (2 * var)) * norm( dataTo(:,i) - (s*R*dataFrom(:,k) + p) ) );
            end
            P(i,j) = numerator / denominator;
        end
    end
    
    Np = ones(1,M) * P * ones(M,1);
    Ux = (1/Np)*dataTo * P' * ones(M,1);
    Uy = (1/Np)*dataFrom * P * ones(N,1);
    X = dataFrom - Ux;
    Y = dataTo - Uy;
    A = X * P' * Y';
    [U,~,V] = svd(A);
    C = diag([1 1 det(U*V')]);
    R = U * C * V';
    s = trace(A' * R) / trace();
    
end

end

