function [ index ] = correlation( mask, inputImage )
%CORRELATION Summary of this function goes here
%   Detailed explanation goes here

maxCorr = 0;
index = [0 0];

sizeImage = size(inputImage);
sizeX = sizeImage(1);
sizeY = sizeImage(2);

sizeMask = size(mask);
maskX = sizeMask(1);
maskY = sizeMask(2);

expandedImage = zeros(sizeX + maskX, sizeY + maskY);

for i = 1:1:sizeX
    for j = 1:1:sizeY
        expandedImage(i + floor(maskX/2),j + floor(maskY/2)) = inputImage(i,j);
    end
end

sizeExp = size(expandedImage);
expX = sizeExp(1);
expY = sizeExp(2);

for i = 1:1:expX - maskX
    for j = 1:1:expY - maskY
        windowedImage = expandedImage(i:i+maskX-1,j:j+maskY-1);
        tempCorr = corr2(mask,windowedImage);
        
        if (tempCorr > maxCorr)
            index = [i j];
            maxCorr = tempCorr;
        end
    end
end