% Example 3. 3D Rigid CPD point-set registration. Full options intialization.
%  3D face point-set.
clear all; close all; clc;

% 4132012 Data New Scan Conversion
% load 'SCCoord2L41320122';
load 'SCCoord2R41320122';
load 'USCoord4132012EllipseAll5';

% 4202012 Data New Scan Conversion
% load 'SCCoordL42020123';
% load 'SCCoordR42020123';
% load 'USCoord4202012EllipseAll3';

X = dataUS';
X(:,3) = -X(:,3);
Y = dataSC';

% Set the options
opt.method='rigid'; % use rigid registration
opt.viz=1;          % show every iteration
opt.outliers=0.5;     % do not assume any noise 

opt.normalize=0;    % normalize to unit variance and zero mean before registering (default)
opt.scale=0;        % estimate global scaling too (default)
opt.rot=1;          % estimate strictly rotational matrix (default)
opt.corresp=1;      % do not compute the correspondence vector at the end of registration (default)

opt.max_it=100;     % max number of iterations
opt.tol=1e-15;       % tolerance


% registering Y to X
[Transform, Correspondence]=cpd_register(X,Y,opt);

figure,cpd_plot_iter(X, Y); title('Before');
figure,cpd_plot_iter(X, Transform.Y);  title('After registering Y to X');

cpd_register(X,Y,opt)