function [ point, diffIm, clipIm, redBwIm, newRedBwIm, newIm ] = get2DCameraPoint( image, imageB, pixel, fraction, spotFindOption, threshold, figures )
%GET2DCAMERAPOINT Summary of this function goes here
%   Detailed explanation goes here

dimensions = size(image);

diffIm = diffImage(image, imageB);

clipIm = clip(diffIm,threshold);

bwIm = im2bw(clipIm);

redBwIm = restrictPixelCount(bwIm,pixel(1),pixel(2));

newRedBwIm = zeros(size(redBwIm));

for i = floor(dimensions(1)*fraction):1:floor(dimensions(1)*(1-fraction))
    for j = floor(dimensions(2)*fraction):1:floor(dimensions(2)*(1-fraction))
        newRedBwIm(i,j) = redBwIm(i,j);
    end
end

[index] = find(newRedBwIm == 1);

newIm = zeros(dimensions);

for i = 1:1:size(index,1)
    newIm(index(i)) = newRedBwIm(index(i));
end

statIm = im2bw(newIm,0);
stats = regionprops(statIm,'all');

for i = 1:1:size(stats,1)
    if (abs(stats(i).MajorAxisLength - stats(i).MinorAxisLength) > 10)
        newIm(stats(i).PixelIdxList) = 0;
    end
end

[point ~] = spotFind(newIm, diffIm, 0, spotFindOption, 0);

if (figures == 1)
    figure;
    imshow(image);
    hold on;
    plot(point(1), point(2),'*w');
    [point ~] = spotFind(newIm, diffIm, 0, spotFindOption, figures);
end

end

