% Load Data
%
% load 2292012BpostK;
% load 2292012p_zx;
% load 2292012RF;
%
% load 3092012BpostK;
% load 3092012p_zx;
% load 3092012RF;

close all;

n = 7;
figures = 1;
spotFindOption = 5;
stepsize = 0.692;

% Thresholds
%
% 2292012
% t1 = [100 100 100 100 100 100 100];
% t2 = [10 0.5 3.5 11 6 3.5 2];
% clipThresh = [500 150 400 500 500 300 250];

% 3092012
% t1 = [100 150 100 90 100 100 100];
% t2 = [2.5 2.5 11 0.8 4 5 2.5];
% clipThresh = [500 500 500 200 800 500 500];

% 3092012-2-4
% t1 = [200 300 300 300 300 400 300];
% t2 = [5 8 10 11 25 25 25];
% clipThresh = [200 500 500 1000 500 1000 1000];

% 3202012
% t1 = [200 300 300 300 300 400 300];
% t2 = [5 8 8 10 54 25 25];
% clipThresh = [200 500 500 1000 500 1000 1000];

% 3202012-2
% t1 = [20 25 30 30 30 40 50];
% t2 = [5 0.24 0.3 0.3 0.5 0.5 0.5];
% clipThresh = [20 50 50 50 50 50 50];

% 3202012-2-4
t1 = [200 300 300 300 300 400 300];
t2 = [5 8 10 11 25 25 25];
clipThresh = [200 500 500 1000 500 1000 1000];

x = zeros(n,2);
y = zeros(n,2);
z = zeros(n,2);

% Dimensions
%
x(:,1) = 0.3;
x(:,2) = 38.4;
y(:,1) = 0.0385;
y(:,2) = 77;
z(:,1) = 0.1;
z(:,2) = 0.1;

% Read in Data
%
% pathStrings = {'First' 'Second' 'Third' 'Fourth' 'Fifth' 'Sixth' 'Seventh'};
% pathStrings = {'1' '2' '3' '4' '5' '6' '7'};
% frame = 3;
% folder = 'C:\Users\Alexis\School\PA\06_Alexis\02_Data\2012.03.09-3DAMSExVivoFatData\';
% 
% for i = 1:1:n
% 
%     path = [folder  char(pathStrings(i)) '\'];
% 
%     [ RF(:,:,:,i), p_zx(:,:,:,i), BpostKAll(:,:,:,i), x(i,:), y(i,:), z(i,:) ] = beamformVolume( path, frame);
% end

% Calculate scales
%
dimensions = size(RF(:,:,:,1));

clipVolume = zeros(dimensions(1),dimensions(2),dimensions(3),n);
meanClipImages = zeros(dimensions(2),dimensions(3),n);
meanClipImagesFinal = zeros(dimensions(2),dimensions(3),n);
tempPoints = zeros(2,n);
plotImage = zeros(dimensions(2),dimensions(3),n);
axial = zeros(n);
points3DPre = zeros(3,n);
points3DPost = zeros(3,n);
sumImage = zeros(dimensions(2),dimensions(3));

scaleX = x(1,2)/dimensions(2);
scaleY = y(1,2)/dimensions(1);

% Segment 3D Points
%

for i = 2:1:n
    
    [meanClipImagesFinal(:,:,i) meanClipImages(:,:,i) clipVolume(:,:,:,i)] = clipMeanVol(BpostKAll, i, t1(i), t2(i));
    
    [tempPoints(:,i) plotImage(:,:,i)] = spotFind(meanClipImagesFinal(:,:,i), meanClipImages(:,:,i), spotFindOption, 0);
    
    if (figures == 1)
        %         plotUSImage(meanClipImages(:,:,i), ['Before Segmentation: ' num2str(i)], 0);
        plotUSImage(plotImage(:,:,i), ['Segmented Image Region: '  num2str(i)], 0);
        plot(tempPoints(1,i), tempPoints(2,i),'*w');
    end
    
    [tempPoints(:,i) ~] = spotFind(meanClipImagesFinal(:,:,i), meanClipImages(:,:,i), spotFindOption, figures);
    
    axial(i) = findAxial(clipVolume, i, tempPoints(2,i), tempPoints(1,i), clipThresh(i));
    
    points3DPre(:,i) = [tempPoints(2,i)*scaleX axial(i)*scaleY 0];
    
    points3DPost(:,i) = Conv2DTo3DProbe(points3DPre(:,i), tempPoints(1,i) - 1, stepsize);
    
end

% Plot all points on 1 image
%
for i = 1:1:n
    sumImage = sumImage + meanClipImagesFinal(:,:,i);
end
plotUSImage(sumImage, 'All Points on 1 plot',0);

% Scale the images to mm
%
% scaleZ = (axial*scaleY + 81)*2*pi*stepsize*29/(55*360);
% for i = 1:1:n
%     figure;
%     imagesc([0,size(meanClipImagesFinal(:,:,i)-1,1)]*scaleX,[0,size(meanClipImagesFinal(:,:,i)-1,2)]*scaleZ(i),meanClipImagesFinal(:,:,i))
%     hold on;
%     plot(tempPoints(1,i)*scaleZ(i),tempPoints(2,i)*scaleX,'*w');
%     axis equal;
% end