% Load Data
%
% load 2292012BpostK;
% load 2292012p_zx;
% load 2292012RF;
%
% load 3092012BpostK;
% load 3092012p_zx;
% load 3092012RF;

close all;

n = 30;
figures = 1;
spotFindOption = 5;
% stepsize = 0.692;
stepsize = 0.4895*2;

% Thresholds
%
t1 = 0.4;

x = zeros(n,2);
y = zeros(n,2);
z = zeros(n,2);

% Read in Data
%
% pathStrings = {'First' 'Second' 'Third' 'Fourth' 'Fifth' 'Sixth' 'Seventh'};
% pathStrings = {'1' '2' '3' '4' '5' '6' '7'};
% frame = 3;
% folder = 'C:\Users\Alexis\School\PA\06_Alexis\02_Data\2012.04.20-AMSExVivoData\';
% 
% RF = zeros(2000,128,31,n);
% p_zx = zeros(2000,128,31,n);
% BpostKAll = zeros(2000,128,31,n);
% 
% for i = 1:1:n
%     
%     %     path = [folder  char(pathStrings(i)) '\'];
%     path = [folder  char(num2str(i)) '\']
%     
%     [ RF(:,:,:,i), p_zx(:,:,:,i), BpostKAll(:,:,:,i), x(i,:), y(i,:), z(i,:) ] = beamformVolume( path, frame);
% end

% Dimensions
%
x(:,1) = 38/128;
x(:,2) = 38;
y(:,1) = 0.0385;
y(:,2) = 77;
z(:,1) = 0.1;
z(:,2) = 0.1;

% Calculate scales
%
% dimensions = size(RF(:,:,:,1));
dimensions = [2000 128 41];

scaledVol = zeros(dimensions(1),dimensions(2),dimensions(3),n);
clipVolume = zeros(dimensions(1),dimensions(2),dimensions(3),n);
meanClipImages = zeros(dimensions(2),dimensions(3),n);
meanClipImagesFinal = zeros(dimensions(2),dimensions(3),n);
shiftedImages = zeros(dimensions(2),dimensions(3),n);
tempPoints = zeros(2,n);
plotImage = zeros(dimensions(2),dimensions(3),n);
axial = zeros(n,1);
shift = zeros(n,1);
points3DPre = zeros(3,n);
points3DPost = zeros(3,n);
sumImage = zeros(dimensions(2),dimensions(3));

scaleX = x(1,2)/dimensions(2);
scaleY = y(1,2)/dimensions(1);

% Segment 3D Points
%

for i = 1:1:1
    
    scaledVol(:,:,:,i) = scaleVolume(BpostKAll(:,:,:,i));
    
    [meanClipImagesFinal(:,:,i) meanClipImages(:,:,i) clipVolume(:,:,:,i)] = clipMeanVol(scaledVol, i, t1, 0);
    
    [shiftedImages(:,:,i) shift(i)] = shiftLateral(meanClipImages(:,:,i));
    
    [tempPoints(:,i) plotImage(:,:,i)] = spotFind(shiftedImages(:,:,i), meanClipImages(:,:,i), shift(i), spotFindOption, 0);
    
    if (figures == 1)
        %         plotUSImage(meanClipImages(:,:,i), ['Before Segmentation: ' num2str(i)], 0);
        plotUSImage(plotImage(:,:,i), ['Segmented Image Region: '  num2str(i)], 0);
        plot(tempPoints(1,i), tempPoints(2,i),'*w');
    end
    
    [tempPoints(:,i) ~] = spotFind(shiftedImages(:,:,i), meanClipImages(:,:,i), shift(i), spotFindOption, figures);
    
    axial(i) = findAxial(clipVolume, i, tempPoints(2,i), tempPoints(1,i), t1);
    
    points3DPre(:,i) = [tempPoints(2,i)*scaleX axial(i)*scaleY 0];
    
    points3DPost(:,i) = Conv2DTo3DProbe(points3DPre(:,i), tempPoints(1,i) - 1, stepsize);
    
end

% Plot all points on 1 image
%
for i = 1:1:n
    sumImage = sumImage + meanClipImagesFinal(:,:,i);
end
plotUSImage(sumImage, 'All Points on 1 plot',0);

% Scale the images to mm
%
% scaleZ = (axial*scaleY + 81)*2*pi*stepsize*29/(55*360);
% for i = 1:1:n
%     figure;
%     imagesc([0,size(meanClipImagesFinal(:,:,i)-1,1)]*scaleX,[0,size(meanClipImagesFinal(:,:,i)-1,2)]*scaleZ(i),meanClipImagesFinal(:,:,i))
%     hold on;
%     plot(tempPoints(1,i)*scaleZ(i),tempPoints(2,i)*scaleX,'*w');
%     axis equal;
% end