function [point3DL, point3DR] = getCameraPoint(image_nameL, image_nameR)

%%%%%%%%%%%%%%%%%%%%% Left Image %%%%%%%%%%%%%%%%%%%%%%%

% Imports image file and converts it to grayscale image
Laser_ColorL=imread(image_nameL);


threshold_levelL = 0.7;
BW_LaserL=im2bw(Laser_ColorL,threshold_levelL);

pixel_countL = 20;
BW_Laser2L=bwareaopen(BW_LaserL,pixel_countL,8);

disp('Please choose the segmented laser spot \n');

BW_Laser_SelectL=bwselect(BW_Laser2L);

figure(1);
imshow(BW_Laser_SelectL)

% Labels the region of the thresholded image so that properties of the user
% selected region can be obtained.
[LL,~]=bwlabeln(BW_Laser_SelectL,8);

% Computes the weighted centroid of the selected region/laser spot.
Coord_StructL=regionprops(LL,BW_Laser_SelectL,'WeightedCentroid');

% Stores the x,y coordinates of the weighted centroid.
vL = Coord_StructL.WeightedCentroid;

%%%%%%%%%%%%%%%%%%%%% Right Image %%%%%%%%%%%%%%%%%%%%%%%%

% Imports image file and converts it to grayscale image
Laser_ColorR=imread(image_nameR);

threshold_levelR = 0.7;
BW_LaserR=im2bw(Laser_ColorR,threshold_levelR);

pixel_countR = 20;
BW_Laser2R=bwareaopen(BW_LaserR,pixel_countR,8);

disp('Please choose the segmented laser spot \n');

BW_Laser_SelectR=bwselect(BW_Laser2R);

figure(1);
imshow(BW_Laser_SelectR)

% Labels the region of the thresholded image so that properties of the user
% selected region can be obtained.
[LR,~]=bwlabeln(BW_Laser_SelectR,8);

% Computes the weighted centroid of the selected region/laser spot.
Coord_StructR=regionprops(LR,BW_Laser_SelectR,'WeightedCentroid');

% Stores the x,y coordinates of the weighted centroid.
vR=Coord_StructR.WeightedCentroid;

[point3DL point3DR] = triangulate(vL, vR);