function [ index ] = pointInEllipse( image, centroid, major, minor, orientation )
%POINTINELLIPSE Summary of this function goes here
%   Detailed explanation goes here

index = [];
dimensions = size(image);

region = [floor(centroid(1)- major/2), ceil(centroid(1) + major/2), floor(centroid(2) - major/2), ceil(centroid(2) + major/2)];

if (region(1) < 1)
    region(1) = 1;
end
if (region(2) > dimensions(2))
    region(2) = dimensions(2);
end
if (region(3) < 1)
    region(3) = 1;
end
if (region(4) > dimensions(1))
    region(4) = dimensions(1);
end

for x = region(1):1:region(2)
    for y = region(3):1:region(4)
        
        axisAngle = [0 0 1 orientation];
        rotMat = vrrotvec2mat(axisAngle);
        relPoint = [(x - centroid(1)) (y - centroid(2)) 0];
        
        rotPoint = rotMat*relPoint';
        
        if ((rotPoint(1)^2/((major/2)^2) + rotPoint(2)^2/((minor/2)^2)) <= 1)
            index = [index; x y];
        end
        
    end
end

end