function [Bpre, Bpost] = quickshow(path,~)

close all;

nCh = 128;              % number of channels
reRoute = true;         % true: transducer element (correct image), false: DAQ element
chanls = ones(1,nCh);   % what channels to read (DAQ element), for each channel set to 1 
                        % if you want to read the data
fulAprSz = 4;
frameN = 5;

dz = 0.1;
dt = 1/(40e6);
speedSound = 1540;
probeL = 38.4;
dx = (probeL * 1e-3)/nCh;

if nargin == 1
    D = dir(path);
    idx = find([D.isdir]);
end

for i = 3:1:idx(end)
    
    folder = [path '\' D(i).name '\'];

    [~, RF] = readDAQ(folder, chanls, frameN, reRoute);
    y = [1 size(RF,1)] * dt * speedSound * 1e3;
    x = [1 size(RF,2)] / nCh * probeL;
    
    Bpre(:,:,i-2) = sqrt( abs( hilbert(RF) ) ) ;
    figure;
    subplot(311);
    imagesc(x, y, Bpre(:,:,i-2));
    colormap(gray);
    title(['Prebeamformed image ', num2str(i-2), ' frame ', num2str( frameN )]);
    axis square;
    xlabel('Distance (mm)')
    ylabel('Distance (mm)')
    
    out = beamformDAQ(RF, fulAprSz, probeL);
    Bpost(:,:,i-2) = sqrt( abs( hilbert(out) ) ) ;
    subplot(312);
    imagesc(x ,y ,Bpost(:,:,i-2));
    colormap(gray);
    title(['Beamformed image Delay-Sum ', num2str(i-2), ' frame ', num2str( frameN )]);
    axis square;
    xlabel('Distance (mm)')
    ylabel('Distance (mm)')
    
    p_zx = kspaceLineRecon(RF,dx,dt,speedSound);
    BpostK(:,:,i-2) = abs(hilbert(p_zx));
    subplot(313);
    imagesc(x ,y ,BpostK(:,:,i-2));
    colormap(gray);
    title(['Beamformed image K-Wave ', num2str(i-2), ' frame ', num2str( frameN )]);
    axis square;
    xlabel('Distance (mm)')
    ylabel('Distance (mm)')
end
