% Usage: 

%[out spacing] = scan_code (StVol, width_in_mm, height_in_mm, step_angle_ams, radius_of_probe, desired_elevation_in_pixels);

%e.g.

%[out spacing] = scan_code (StVol, 38, 35, 0.346, 81, 400);
% Author: Nishikant Deshmukh (c) MUSiiC Lab www.musiic.org
% email: nishikant@jhu.edu

% width = 38;
% height = 35;
% step_ang = 0.346;
% 
% proberad = 81;
% desired_z = 400;

function [final spacing] = scan_code(StVol, width, height, step_ang, proberad, desired_z)
% out = zeros([],[], dim(2));
% final_out = zeros([],dim(2),[]);
dim = size (StVol);
spacing_height = height/dim(1);
for i=1:dim(2)
[out(:,:,i) spacing_z]=linear2sector(StVol(:,i,:),proberad/spacing_height, dim(3) * step_ang, spacing_height, desired_z);
final_out(:,i,:)=interpscimg(out(:,:,i));
end;
dim1 = size(final_out);

dim1 (2) = round(dim1(1) * width /height);
for i=1:dim1(3)
final(:,:,i)=resizem(final_out(:,:,i), [dim1(1) dim1(2)],'bilinear');
end;

dim2 = size (final);

spacing = [height / dim2(1) width / dim2(2) spacing_z];
