function [ shiftedImage, shift ] = shiftLateral( image )
%SHIFTLATERAL Summary of this function goes here
%   Detailed explanation goes here

[nline nslice] = size(image);

shiftedImage = zeros(nline,nslice);

bw = im2bw(image,0);

stats = regionprops(bw,'all');

sumTop = 0;
sumBot = 0;

if size(stats,1) > 1
    idtop = stats(1).PixelList;
    idbot = stats(2).PixelList;
    
    idtopX = idtop(:,2);
    idtopY = idtop(:,1);
    idbotX = idbot(:,2);
    idbotY = idbot(:,1);
    
    for i = 1:1:size(idtopX,1)
        sumTop = sumTop + image(idtopX(i),idtopY(i));
    end
    
    for i = 1:1:size(idbotX,1)
        sumBot = sumBot + image(idbotX(i),idbotY(i));
    end
    
    if (sumTop > sumBot)
        shift = - stats(2).BoundingBox(4);
    else
        shift = stats(1).BoundingBox(4);
    end
    
    for j = 1:1:size(image,1)
        
        tempInd = j + shift;
        
        if (tempInd > nline)
            tempInd = tempInd - nline;
        elseif (tempInd < 1)
            tempInd = tempInd + nline;
        end
        
        shiftedImage(j,:) = image(tempInd,:);
    end
else
    shiftedImage = image;
    shift = 0;
end

end

