function [ points, plotImage ] = spotFindEllipseAll( imageF, image, shift, figures )
%SPOTFINDELLIPSEALL Summary of this function goes here
%   Detailed explanation goes here

sumIntensity = 0;
pointsTotal = [0 0];
[nline ~] = size(image);

bwImage = im2bw(imageF,0);

statsAll = regionprops(bwImage,'all');

max = statsAll(1).Area;
stats = statsAll(1);

for i = 2:1:size(statsAll,1)
    if statsAll(i).Area > max
        stats = statsAll(i);
        max = statsAll(i).Area;
    end
end

orientationRad = - degtorad(stats.Orientation);

index = pointInEllipse(imageF, stats.Centroid', stats.MajorAxisLength, stats.MinorAxisLength, - orientationRad);

if (strcmp(class(image),'uint8'))
    image = double(image) + 1;
end

for i = 1:1:size(index,1)
    x = index(i,1);
    shiftY = index(i,2) + shift;
    y = shiftY;
    if (shiftY > nline)
        y = shiftY - nline;
    elseif (shiftY < 1)
        y = shiftY + nline;
    end
    
    sumIntensity = sumIntensity + image(y,x);
    pointsTotal = pointsTotal + [x shiftY]*image(y,x);
end

points = pointsTotal/sumIntensity;

if (points(2) > nline)
    points(2) = points(2) - nline;
elseif (points(2) < 1)
    points(2) = points(2) + nline;
end

if (shift ~= 0)
    plotImage = image;
    
    if (shift > 0)
        plotImage(1:shift,:) = 0;
    elseif (shift < 0)
        plotImage(nline+shift:nline,:) = 0;
    end
else
    plotImage = getMaskImage(image, index);
end

if (figures == 1)
    ellipse(stats.MajorAxisLength/2,stats.MinorAxisLength/2,orientationRad,points(1),points(2),'w');
end

end

