folder = 'C:\Users\Alexis\School\PA\CameraSpotsAll\CameraSpots-3-20-2012\';
pathStrings = {'1' '2' '3' '4' '5' '6' '7'};

load 'testSCData.mat';
load 'testUSData.mat';

n = size(pathStrings,2);

for i = 1:1:n
    
    path = [folder  char(pathStrings(i)) '\'];
    imPathL(i,:) = [path 'ImageL.jpg'];
    imPathR(i,:) = [path 'ImageR.jpg'];
    
    imL(:,:,:,i) = imread(imPathL(i,:));
    imR(:,:,:,i) = imread(imPathR(i,:));
end

image = zeros(2000,128);
stepsize = 0.692;
steps = 40;
sampling = [50 4 4];
scale = [0.0385 0.3];

fc = 3117;
cc_right=[917.3233 460.0431]';
cc_left=[212.7715 460.0431]';
T = -168.5713;

registration = [];
translation = [];
leave = 1;

[finReg finTrans] = getRegistrations( registration, translation, dataSC, dataUS, leave );

pointList3D = getUSRepresentation3D(image , stepsize, steps, sampling, scale )';

pointList2D = zeros(2,size(pointList3D,2),size(finReg,3));
transPoints3D = zeros(3,size(pointList3D,2),size(finReg,3));

newRot = zeros(3,3,size(finReg,3));
newTrans = zeros(3,size(finReg,3));

for j = 1:1:size(finReg,3)
    
    [newRot(:,:,j) newTrans(:,j)] = getInverseMatrix(finReg(:,:,j), finTrans(:,j));
    
    for i = 1:1:size(pointList3D,2)
        transPoints3D(:,i,j) = newRot(:,:,j)*pointList3D(:,i) + newTrans(:,j);
        
        pointList2D(1,i,j) = transPoints3D(1,i,j)*fc/transPoints3D(3,i,j);
        pointList2D(2,i,j) = transPoints3D(2,i,j)*fc/transPoints3D(3,i,j);
        
        pointList2D(:,i,j) = pointList2D(:,i,j) + cc_right;
    end
    
    figure;
    imshow(rgb2gray(imR(:,:,:,1)));
    hold on;
    plot(pointList2D(1,:,j),pointList2D(2,:,j),'.w');
end