% folder = 'C:\Users\Alexis\School\PA\CameraSpotsAll\CameraSpots-3-20-2012\';
folder = 'C:\Users\Alexis\School\PA\CameraSpotsAll\CameraSpots-4-20-2012\';
pathStrings = {'1' '2' '3' '4' '5' '6' '7'};

% load 'testSCData.mat';
% load 'testUSData.mat';

load 'testSCData2.mat';
load 'testUSData2.mat';

% load 'SCCoord2R41320122';
% load 'USCoord4132012EllipseAll5';

n = size(pathStrings,2);

for i = 1:1:n
    
    path = [folder  char(pathStrings(i)) '\'];
    imPathL(i,:) = [path 'ImageL.jpg'];
    imPathR(i,:) = [path 'ImageR.jpg'];
    
    imL(:,:,:,i) = imread(imPathL(i,:));
    imR(:,:,:,i) = imread(imPathR(i,:));
end

image = zeros(2000,128);
stepsize = 0.692;
steps = 30;
sampling = [50 4 4];
scale = [0.0385 0.3];

fc = 3117;
cc_right=[917.3233 460.0431]';
cc_left=[212.7715 460.0431]';

registration = [];
translation = [];
leave = 1;

[finReg finTrans] = getRegistrations( registration, translation, dataSC, dataUS, leave );

[newRot newTrans] = getInverseMatrix(finReg(:,:,1), finTrans(:,1));

pointListSlice = getUSRepresentationSlice(image , stepsize, 0, sampling, scale )';

transPoints3D = zeros(3,size(pointListSlice,2),steps+1);

writerObj = VideoWriter('USdemoMovie.avi');
writerObj.FrameRate = 30;
open(writerObj);

imshow(imR(:,:,:,1));
fig1 = figure(1);
winsize = get(fig1,'Position');
winsize(1:2) = [0 0];
numframes = steps+1;
A = moviein(numframes,fig1,winsize);
set(fig1,'NextPlot','replacechildren');

for j = 0:1:steps
    
    pointListSlice(:,:,j+1) = getUSRepresentationSlice(image , stepsize, j, sampling, scale )';
    
    for i = 1:1:size(pointListSlice(:,:,j+1),2)
        transPoints3D(:,i,j+1) = newRot*pointListSlice(:,i,j+1) + newTrans;
        
        pointList2D(:,i,j+1) = reproject2D(transPoints3D(:,i,j+1),fc,cc_right);
    end
    
    imshow(imR(:,:,:,1));
    hold on;
    plot(pointList2D(1,:,j+1),pointList2D(2,:,j+1),'.w');
    A(j+1) = getframe(fig1,winsize);
    writeVideo(writerObj,A(j+1));
    
end

for i = 1:1:19
    writeVideo(writerObj,A);
end

close(writerObj);